package com.jkcredit.illegal.info.util;


import org.apache.commons.codec.binary.Base64;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESedeKeySpec;


public class DES3 {

    public static final String ALGORITHM = "DESede";
    public static final String ALGORITHMCipher = "DESede/ECB/PKCS5Padding";
    public static final String UTF8 = "UTF-8";


    /**
     * 加密
     *
     * @param
     * @return secretKey  密钥
     * @throws Exception
     */
    public static String getEncString(String strMing, String secretKey) throws Exception {
        SecretKey sKsecretKey = getKey(secretKey);
        Cipher cipher = Cipher.getInstance(ALGORITHMCipher);
        cipher.init(Cipher.ENCRYPT_MODE, sKsecretKey);
        byte[] byteMi = cipher.doFinal(strMing.getBytes(UTF8));
        return new BASE64Encoder().encode(byteMi);
    }


    /**
     * 解密
     *
     * @param
     * @return secretKey  密钥
     * @throws Exception
     */
    public static String getDecString(String paramAfterEncrypt, String secretKey) throws Exception {
        SecretKey sKsecretKey = getKey(secretKey);
        Cipher cipher = Cipher.getInstance(ALGORITHMCipher);
        cipher.init(Cipher.DECRYPT_MODE, sKsecretKey);
        byte[] byteMing = cipher.doFinal(new Base64().decode(paramAfterEncrypt));
        return new String(byteMing, "UTF-8");
    }


    /**
     * 使用DESede对secretKey进行加密
     *
     * @param secretKey 密钥
     * @throws Exception
     */
    public static SecretKey getKey(String secretKey) throws Exception {
        byte[] keyBytes = new BASE64Decoder().decodeBuffer(secretKey);
        DESedeKeySpec dks = new DESedeKeySpec(keyBytes);
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance(ALGORITHM);
        SecretKey sKsecretKey = keyFactory.generateSecret(dks);
        return sKsecretKey;
    }


}
